'use strict';

exports.__esModule = true;
exports.FormItem = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FormModel = require('./FormModel');

var _FormItemModel = require('./FormItemModel');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormItem = function (_React$PureComponent) {
  (0, _inherits3.default)(FormItem, _React$PureComponent);

  function FormItem(props, context) {
    (0, _classCallCheck3.default)(this, FormItem);

    var _this = (0, _possibleConstructorReturn3.default)(this, _React$PureComponent.call(this, props, context));

    var formModel = context.formModel,
        formItemModel = context.formItemModel;

    _this.forms = formModel.forms;
    if (formItemModel && props.asChild) {
      _this.forms = formItemModel.forms;
    }
    _this.formItemModel = _this.forms.add(props, !!props.asList);
    _this.formModel = formModel;
    return _this;
  }

  FormItem.prototype.getChildContext = function getChildContext() {
    return { formItemModel: this.formItemModel };
  };

  FormItem.prototype.componentDidMount = function componentDidMount() {
    if (this.formModel.initialized) {
      this.formModel.validate();
    }
  };

  FormItem.prototype.componentWillUnmount = function componentWillUnmount() {
    this.forms.remove(this.formItemModel);
    if (this.formModel.initialized) {
      this.formModel.validate();
    }
  };

  FormItem.prototype.render = function render() {
    var children = this.props.children;

    return _react2.default.createElement(
      'div',
      null,
      children
    );
  };

  return FormItem;
}(_react2.default.PureComponent);

FormItem.propTypes = {
  name: _propTypes2.default.string.isRequired,
  validator: _propTypes2.default.func,
  asList: _propTypes2.default.bool,
  asChild: _propTypes2.default.bool,
  excluded: _propTypes2.default.bool,
  children: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.arrayOf(_propTypes2.default.element)]).isRequired
};
FormItem.defaultProps = {
  asList: false,
  asChild: false,
  excluded: false,
  validator: function validator() {
    return [];
  }
};
FormItem.contextTypes = {
  formModel: _propTypes2.default.instanceOf(_FormModel.FormModel).isRequired,
  formItemModel: _propTypes2.default.instanceOf(_FormItemModel.FormItemModel)
};
FormItem.childContextTypes = {
  formItemModel: _propTypes2.default.instanceOf(_FormItemModel.FormItemModel).isRequired
};
exports.FormItem = FormItem;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(FormItem, 'FormItem', '/Users/flamps/Documents/React/Flamps/vb-react-form/src/FormsV1/Form/FormItem.js');
}();

;