'use strict';

exports.__esModule = true;
exports.FormModel = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _v = require('uuid/v1');

var _v2 = _interopRequireDefault(_v);

var _lodash = require('lodash');

var _PubSub = require('../PubSub');

var _PubSub2 = _interopRequireDefault(_PubSub);

var _FieldsModel = require('./FieldsModel');

var _FieldsModel2 = _interopRequireDefault(_FieldsModel);

var _FormsModel = require('./FormsModel');

var _FormsModel2 = _interopRequireDefault(_FormsModel);

var _FormModelPublic = require('./public/FormModelPublic');

var _FormModelPublic2 = _interopRequireDefault(_FormModelPublic);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormModel = function () {
  function FormModel(name, validator, onChange, parent) {
    var _this = this;

    (0, _classCallCheck3.default)(this, FormModel);

    this.getPublic = function () {
      return _this.__getPublic__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.completed = function () {
      return _this.__completed__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.willDelete = function () {
      return _this.__willDelete__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.validate = function () {
      return _this.__validate__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.refresh = function () {
      return _this.__refresh__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.reload = function () {
      return _this.__reload__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.reset = function () {
      return _this.__reset__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.init = function () {
      return _this.__init__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.makeDirty = function () {
      return _this.__makeDirty__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.makeSubmitted = function () {
      return _this.__makeSubmitted__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isValid = function () {
      return _this.__isValid__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isTouched = function () {
      return _this.__isTouched__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isSubmitted = function () {
      return _this.__isSubmitted__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.data = function () {
      return _this.__data__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.values = function () {
      return _this.__values__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.updateErrors = function () {
      return _this.__updateErrors__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.getErrors = function () {
      return _this.__getErrors__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.addSubscriber = function () {
      return _this.__addSubscriber__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.removeSubscriber = function () {
      return _this.__removeSubscriber__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.publish = function () {
      return _this.__publish__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.id = (0, _v2.default)();
    this.parent = parent;
    this.name = name;
    this.validator = validator;
    this.initialized = false;
    this.submitted = false;
    this.subscribers = new _PubSub2.default();
    this.fields = new _FieldsModel2.default();
    this.forms = new _FormsModel2.default();
    this.errors = [];
    this.onChange = onChange || function () {};
    this.public = new _FormModelPublic2.default(this);
    this.refreshDebounce = (0, _lodash.debounce)(this.refresh, 100);
  }

  FormModel.prototype.__publish__REACT_HOT_LOADER__ = function __publish__REACT_HOT_LOADER__() {
    return this.__publish__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__removeSubscriber__REACT_HOT_LOADER__ = function __removeSubscriber__REACT_HOT_LOADER__() {
    return this.__removeSubscriber__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__addSubscriber__REACT_HOT_LOADER__ = function __addSubscriber__REACT_HOT_LOADER__() {
    return this.__addSubscriber__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__getErrors__REACT_HOT_LOADER__ = function __getErrors__REACT_HOT_LOADER__() {
    return this.__getErrors__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__updateErrors__REACT_HOT_LOADER__ = function __updateErrors__REACT_HOT_LOADER__() {
    return this.__updateErrors__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__values__REACT_HOT_LOADER__ = function __values__REACT_HOT_LOADER__() {
    return this.__values__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__data__REACT_HOT_LOADER__ = function __data__REACT_HOT_LOADER__() {
    return this.__data__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__isSubmitted__REACT_HOT_LOADER__ = function __isSubmitted__REACT_HOT_LOADER__() {
    return this.__isSubmitted__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__isTouched__REACT_HOT_LOADER__ = function __isTouched__REACT_HOT_LOADER__() {
    return this.__isTouched__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__isValid__REACT_HOT_LOADER__ = function __isValid__REACT_HOT_LOADER__() {
    return this.__isValid__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__makeSubmitted__REACT_HOT_LOADER__ = function __makeSubmitted__REACT_HOT_LOADER__() {
    return this.__makeSubmitted__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__makeDirty__REACT_HOT_LOADER__ = function __makeDirty__REACT_HOT_LOADER__() {
    return this.__makeDirty__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__init__REACT_HOT_LOADER__ = function __init__REACT_HOT_LOADER__() {
    return this.__init__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__reset__REACT_HOT_LOADER__ = function __reset__REACT_HOT_LOADER__() {
    return this.__reset__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__reload__REACT_HOT_LOADER__ = function __reload__REACT_HOT_LOADER__() {
    return this.__reload__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__refresh__REACT_HOT_LOADER__ = function __refresh__REACT_HOT_LOADER__() {
    return this.__refresh__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__validate__REACT_HOT_LOADER__ = function __validate__REACT_HOT_LOADER__() {
    return this.__validate__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__willDelete__REACT_HOT_LOADER__ = function __willDelete__REACT_HOT_LOADER__() {
    return this.__willDelete__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__completed__REACT_HOT_LOADER__ = function __completed__REACT_HOT_LOADER__() {
    return this.__completed__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__getPublic__REACT_HOT_LOADER__ = function __getPublic__REACT_HOT_LOADER__() {
    return this.__getPublic__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormModel.prototype.__getPublic__REACT_HOT_LOADER__ = function __getPublic__REACT_HOT_LOADER__() {
    return this.public;
  };

  FormModel.prototype.__completed__REACT_HOT_LOADER__ = function __completed__REACT_HOT_LOADER__() {
    this.initialized = true;
  };

  FormModel.prototype.__willDelete__REACT_HOT_LOADER__ = function __willDelete__REACT_HOT_LOADER__() {
    this.initialized = false;
    this.subscribers.unsubscribeAll();
    this.onChange = function () {};
  };

  FormModel.prototype.__validate__REACT_HOT_LOADER__ = function __validate__REACT_HOT_LOADER__() {
    this.fields.validate();
    this.forms.validate();
    this.refresh();
  };

  FormModel.prototype.__refresh__REACT_HOT_LOADER__ = function __refresh__REACT_HOT_LOADER__() {
    var errors = this.validator(this.getPublic());
    this.updateErrors(errors['']);
    this.fields.addErrors(errors);
    this.forms.addErrors(errors);
    this.reload();
    this.publish();
    if (this.initialized) {
      this.onChange(this.getPublic());
    }
  };

  FormModel.prototype.__reload__REACT_HOT_LOADER__ = function __reload__REACT_HOT_LOADER__() {
    this.fields.reload();
    this.forms.reload();
  };

  FormModel.prototype.__reset__REACT_HOT_LOADER__ = function __reset__REACT_HOT_LOADER__() {
    this.submitted = false;
    this.fields.reset();
    this.forms.reset();
    this.validate();
  };

  FormModel.prototype.__init__REACT_HOT_LOADER__ = function __init__REACT_HOT_LOADER__() {
    var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var makeDirty = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    this.submitted = false;
    this.fields.reset();
    this.forms.reset();
    this.fields.init(data);
    this.forms.init(data);
    if (makeDirty) {
      this.fields.makeDirty();
      this.forms.makeDirty();
    }
    this.validate();
  };

  FormModel.prototype.__makeDirty__REACT_HOT_LOADER__ = function __makeDirty__REACT_HOT_LOADER__() {
    this.fields.makeDirty();
    this.forms.makeDirty();
    this.validate();
  };

  FormModel.prototype.__makeSubmitted__REACT_HOT_LOADER__ = function __makeSubmitted__REACT_HOT_LOADER__() {
    this.submitted = true;
    this.fields.makeSubmitted();
    this.forms.makeSubmitted();
    this.reload();
    this.publish();
  };

  FormModel.prototype.__isValid__REACT_HOT_LOADER__ = function __isValid__REACT_HOT_LOADER__() {
    return !this.errors.length && this.fields.isValid() && this.forms.isValid();
  };

  FormModel.prototype.__isTouched__REACT_HOT_LOADER__ = function __isTouched__REACT_HOT_LOADER__() {
    return this.fields.isTouched() || this.forms.isTouched();
  };

  FormModel.prototype.__isSubmitted__REACT_HOT_LOADER__ = function __isSubmitted__REACT_HOT_LOADER__() {
    return this.submitted;
  };

  FormModel.prototype.__data__REACT_HOT_LOADER__ = function __data__REACT_HOT_LOADER__() {
    return (0, _extends3.default)({}, this.fields.data(), this.forms.data());
  };

  FormModel.prototype.__values__REACT_HOT_LOADER__ = function __values__REACT_HOT_LOADER__() {
    return (0, _extends3.default)({}, this.fields.values(), this.forms.values());
  };

  FormModel.prototype.__updateErrors__REACT_HOT_LOADER__ = function __updateErrors__REACT_HOT_LOADER__(errors) {
    this.errors = [];
    if (Array.isArray(errors)) {
      this.errors = errors;
    } else if (errors) {
      this.errors = [errors];
    }
  };

  FormModel.prototype.__getErrors__REACT_HOT_LOADER__ = function __getErrors__REACT_HOT_LOADER__() {
    return {
      fields: this.fields.errors(),
      forms: this.forms.errors(),
      form: this.errors
    };
  };

  FormModel.prototype.__addSubscriber__REACT_HOT_LOADER__ = function __addSubscriber__REACT_HOT_LOADER__(fn) {
    var subscriberId = this.subscribers.subscribe(fn);
    if (this.initialized) {
      this.publish();
    }
    return subscriberId;
  };

  FormModel.prototype.__removeSubscriber__REACT_HOT_LOADER__ = function __removeSubscriber__REACT_HOT_LOADER__(id) {
    return this.subscribers.unsubscribe(id);
  };

  FormModel.prototype.__publish__REACT_HOT_LOADER__ = function __publish__REACT_HOT_LOADER__() {
    this.subscribers.publish();
  };

  return FormModel;
}();

exports.FormModel = FormModel;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(FormModel, 'FormModel', '/Users/flamps/Documents/React/Flamps/vb-react-form/src/FormsV1/Form/FormModel.js');
}();

;