'use strict';

exports.__esModule = true;
exports.FieldErrors = exports.FormField = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _FormModel = require('../Form/FormModel');

var _FormItemModel = require('../Form/FormItemModel');

var _FieldErrors = require('./FieldErrors');

var _getElementProps = require('./getElementProps');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormField = function (_Component) {
  (0, _inherits3.default)(FormField, _Component);

  function FormField(props, context) {
    (0, _classCallCheck3.default)(this, FormField);

    var _this = (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props, context));

    _this.handleReload = function () {
      return _this.__handleReload__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.onChange = function () {
      return _this.__onChange__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.onFocus = function () {
      return _this.__onFocus__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.onBlur = function () {
      return _this.__onBlur__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    var formModel = context.formModel,
        formItemModel = context.formItemModel;


    _this.fields = formModel.fields;
    if (formItemModel) {
      _this.fields = formItemModel.fields;
    }
    _this.model = _this.fields.add((0, _extends3.default)({ component: _this, reload: _this.handleReload }, props));
    _this.formModel = formModel;
    _this.formItemModel = formItemModel;
    return _this;
  }

  FormField.prototype.__onBlur__REACT_HOT_LOADER__ = function __onBlur__REACT_HOT_LOADER__() {
    return this.__onBlur__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormField.prototype.__onFocus__REACT_HOT_LOADER__ = function __onFocus__REACT_HOT_LOADER__() {
    return this.__onFocus__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormField.prototype.__onChange__REACT_HOT_LOADER__ = function __onChange__REACT_HOT_LOADER__() {
    return this.__onChange__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormField.prototype.__handleReload__REACT_HOT_LOADER__ = function __handleReload__REACT_HOT_LOADER__() {
    return this.__handleReload__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FormField.prototype.componentDidMount = function componentDidMount() {
    if (this.formModel.initialized) {
      this.formModel.validate();
    }
  };

  FormField.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    this.model.setSubmissionErrors(nextProps.submissionErrors);
    if (!(0, _lodash.isEqual)(this.props.submissionErrors, nextProps.submissionErrors)) {
      if (this.formModel.initialized) {
        this.formModel.refreshDebounce();
      }
    }
  };

  FormField.prototype.shouldComponentUpdate = function shouldComponentUpdate() {
    return false;
  };

  FormField.prototype.componentWillUnmount = function componentWillUnmount() {
    this.fields.remove(this.model.name);
    if (this.formModel.initialized) {
      this.formModel.validate();
    }
  };

  FormField.prototype.__handleReload__REACT_HOT_LOADER__ = function __handleReload__REACT_HOT_LOADER__() {
    this.forceUpdate();
    this.props.onUpdate(this.model.getPublic());
    this.props.onFieldChange(this.model.getPublic());
  };

  FormField.prototype.__onChange__REACT_HOT_LOADER__ = function __onChange__REACT_HOT_LOADER__() {
    var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

    if (this.model.submitted) {
      this.model.changedAfterSubmit = true;
    }
    this.model.setValue(value);
    this.model.setDirty(true);
    this.model.validate();
    this.formModel.refresh();

    this.props.onChange(this.model.getPublic());
  };

  FormField.prototype.__onFocus__REACT_HOT_LOADER__ = function __onFocus__REACT_HOT_LOADER__() {
    this.model.setFocus(true);
    this.model.validate();
    this.formModel.refresh();

    this.props.onFocus(this.model.getPublic());
  };

  FormField.prototype.__onBlur__REACT_HOT_LOADER__ = function __onBlur__REACT_HOT_LOADER__() {
    this.model.setFocus(false);
    this.model.setTouched(true);
    this.model.validate();
    this.formModel.refresh();

    this.props.onBlur(this.model.getPublic());
  };

  FormField.prototype.render = function render() {
    var _props = this.props,
        component = _props.component,
        includeModel = _props.includeModel;


    var props = (0, _extends3.default)({}, (0, _getElementProps.getElementProps)(this.props), {
      value: this.model.value,
      onFocus: this.onFocus,
      onChange: this.onChange,
      onBlur: this.onBlur
    });
    if (includeModel) {
      props.model = this.model.getPublic();
    }
    return _react2.default.createElement(component, props);
  };

  return FormField;
}(_react.Component);

FormField.propTypes = {
  onFocus: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  onBlur: _propTypes2.default.func,
  onUpdate: _propTypes2.default.func,
  onFieldChange: _propTypes2.default.func
};
FormField.defaultProps = {
  onFocus: function onFocus() {},
  onChange: function onChange() {},
  onBlur: function onBlur() {},
  onUpdate: function onUpdate() {},
  onFieldChange: function onFieldChange() {}
};
FormField.contextTypes = {
  formModel: _propTypes2.default.instanceOf(_FormModel.FormModel).isRequired,
  formItemModel: _propTypes2.default.instanceOf(_FormItemModel.FormItemModel) };
exports.FormField = FormField;
exports.FieldErrors = _FieldErrors.FieldErrors;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(FormField, 'FormField', '/Users/flamps/Documents/React/Flamps/vb-react-form/src/FormsV1/FormField/index.js');
}();

;